﻿using System;
using System.Collections.ObjectModel;
using System.Windows.Media;
using Telerik.Windows.Controls;

namespace BaseApplicationProject.ViewModels
{
    public class SeriesViewModel : ViewModelBase
    {
        public ObservableCollection<DataItem> DataItems { get; set; }

        private bool showLabels;
        public bool ShowLabels
        {
            get
            {
                return this.showLabels;
            }
            set
            {
                if (this.showLabels != value)
                {
                    this.showLabels = value;
                   
                    OnPropertyChanged("ShowLabels");
                }
            }
        }
    }

    public class DataItem : ViewModelBase
    {
        public double Year { get; set; }
        public double Value { get; set; }
    }

    public class MainViewModel : ViewModelBase
    {
        private bool showLabels;
        public bool ShowLabels
        {
            get
            {
                return this.showLabels;
            }
            set
            {
                if (this.showLabels != value)
                {
                    this.showLabels = value;
                    ChangeDataLabelsVisibility(this.showLabels);
                    OnPropertyChanged("ShowLabels");
                }
            }
        }

        public ObservableCollection<SeriesViewModel> Data { get; set; }

        public MainViewModel()
        {
            this.Data = GetSampleData();
        }
        
        private void ChangeDataLabelsVisibility(bool shouldBeVisible)
        {
            foreach (SeriesViewModel team in this.Data)
            {
                team.ShowLabels = shouldBeVisible;
            }
        }

        private ObservableCollection<SeriesViewModel> GetSampleData()
        {
            var result = new ObservableCollection<SeriesViewModel>();
            var randomNumGenerator = new Random();

            //for (int i = 0; i <= 2; i++)
            //{   
                result.Add(new SeriesViewModel
                {
                    DataItems = new ObservableCollection<DataItem>()
                    {                                                
                       new DataItem 
                       { 
                           Year = 2013, 
                           Value = randomNumGenerator.Next(50, 100), 
                       },
                       new DataItem 
                       { 
                           Year = 2014, 
                           Value = randomNumGenerator.Next(50, 100),
                       },
                       new DataItem 
                       { 
                           Year = 2015, 
                           Value = randomNumGenerator.Next(50, 100), 
                       },
                       new DataItem 
                       { 
                           Year = 2016, 
                           Value = randomNumGenerator.Next(50, 100), 
                       },
                    }
                });

                result.Add(new SeriesViewModel
                {
                    DataItems = new ObservableCollection<DataItem>()
                    {                        
                       new DataItem 
                       { 
                           Year = 2013, 
                           Value = randomNumGenerator.Next(50, 100), 
                       },
                       new DataItem 
                       { 
                           Year = 2014, 
                           Value = randomNumGenerator.Next(50, 100), 
                       },
                       new DataItem 
                       { 
                           Year = 2015, 
                           Value = randomNumGenerator.Next(50, 100), 
                       },
                       new DataItem 
                       { 
                           Year = 2016, 
                           Value = randomNumGenerator.Next(50, 100), 
                       },
                    }
                });
            //}

            return result;
        }
    }
}
